﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

[ExecuteInEditMode]
[RequireComponent(typeof(Camera))]
public class BackgroundEffect : PostEffectsBase {

    public Texture2D backgroundTex;
    [Range(0,1)]
    public float mixRate = 0.5f;

    void Start() {
        shader = Shader.Find("NPR/Background");
        CreateMaterial();
    }

    void OnRenderImage(RenderTexture source, RenderTexture destination) {
        if (CreateMaterial()) {
            material.SetFloat("mixRate", mixRate);
            material.SetTexture("backgroundTex", backgroundTex);
            Graphics.Blit(source, destination, material);
        }
        else {
            Graphics.Blit(source, destination);
        }
    }
}
