﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

[ExecuteInEditMode]
[RequireComponent(typeof(Camera))]
public class KuwaharaFilter : PostEffectsBase {
    [Range(0, 20)]
    public int filterSize = 5;
    [Range(1,20)]
    public int iterations = 1;
    void Start()
    {
        shader = Shader.Find("NPR/KuwaharaFilter");
        CreateMaterial();
    }

    void OnRenderImage(RenderTexture source, RenderTexture destination)
    {
        if (CreateMaterial())
        {
            RenderTexture tmp = RenderTexture.GetTemporary(source.width, source.height, 0, RenderTextureFormat.DefaultHDR);
            RenderTexture rt1 = source;
            RenderTexture rt2 = tmp;
            material.SetInt("filterSize", filterSize);
            for (int i = 0; i < iterations; ++i)
            {
                if (i == iterations - 1)
                    rt2 = destination;
                Graphics.Blit(rt1, rt2, material);
                RenderTexture t = rt2;
                rt2 = rt1;
                rt1 = t;
            }
            tmp.Release();
        }
        else
        {
            Graphics.Blit(source, destination);
        }
    }
}
